#include <stdio.h>
#include <math.h>
#define DIR "/line7/bg/"
#define ndate 33
int obsdate[ndate]={ 
      150114,150115,150116,150117,150118,
      150208,150209,150210,150211,150212,
      150313,150314,150315,150316,150320,
      150321,150322,150323,150324,
      150412,150413,150414,150415,150417,
      150418,150419,150420,150424,150426,
      150509,150510,150513,150514
    } ;
char head[72][80],color;
FILE *fp,*fp1,*fp2;

main(int ac,char **av)
{
  char a[120],f1[50],t[80];
  int ip,i,j,k,ie,jp;
  int usl,u1,u3;
  float c1,c3,r1,r3;
  float sky1,sky3,see1,see3;
  float a1,a2,a3,a4;
  char obj[8];
  int date,num,ccdno,gate;
  int ng=0;
  float x;
  if(ac<2){ printf("\n\t*** produce calig.dat ******\n");
            printf("\n\tcalig !  (at any directory)\n\n");
            exit(0); }
  fp2=fopen("calig.dat","w");
  fprintf(fp2,"#   date/name       Dr10 Cali29 rms  matched  sky  see");
  fprintf(fp2,"   A73  rms  match  a731  a732  a733  a734  exp  obj\n#"); 
  for(i=0;i<105;i++)fprintf(fp2,"-"); fprintf(fp2,"\n");
  for(ip=0;ip<ndate;ip++){ jp=0;
    printf("%d ",obsdate[ip]); if(ip%10==9){ printf("\n"); fflush(stdout); }
    sprintf(a,"ls %s/%d/p*.fit >1.1",DIR,obsdate[ip]);
    system(a);
    fp1=fopen("1.1","r");
l10:
    fgets(a,120,fp1); if(feof(fp1))goto l20;
    strcpy(f1,a); k=strlen(f1); f1[k-1]=0;
    fp=fopen(f1,"rb");  jp++;
    fread(head,72,80,fp); fclose(fp);
    c1=r1=0; u1=usl=0;
    k=indexpos(head,"CALIBRAT",72);
    if(k!=72){
      sscanf(&head[k][20],"%f",&c1);
      sscanf(&head[k][37],"%f",&r1);
      if(head[k][36]!=32){
        sscanf(&head[k][48],"%d",&usl);
        sscanf(&head[k][62],"%d",&u1);
      } else {
        for(i=42;i<66;i++)if(head[k][i]<48 || head[k][i]>57)head[k][i]=32;
        sscanf(&head[k][42],"%d%d%d",&usl,&u1,&k); // nccd,star,iturn
        if(usl>9)usl=9; usl=usl*100+k; usl=-usl;  
      }
    }
    k=indexpos(head,"SKYADU  ",72);
    sscanf(&head[k][20],"%f",&sky1);
    sscanf(&head[k+1][20],"%f",&see1);
    k=indexpos(head,"EXPTIME ",72);
    sscanf(&head[k][20],"%f",&c3); ie=c3+0.5;
    k=indexpos(head,"OBJECT  ",72);
    for(i=0;i<7;i++)obj[i]=head[k][i+11]; obj[i]=0;
    
    u3=0; c3=r3=a1=a2=a3=a4=0;
    
    i=strlen(DIR)+1; f1[i+19]=0;
    if(head[60][29]!=32){ sscanf(&head[60][20],"%f",&c3);
      sscanf(&head[60][37],"%f",&r3);  sscanf(&head[60][62],"%d",&u3); }
    if(head[61][29]!=32){ sscanf(&head[61][62],"%d",&j);
      sscanf(&head[61][37],"%f",&x);
      if(j>=8 || x==0.)sscanf(&head[61][20],"%f",&a1); }
    if(head[62][29]!=32){ sscanf(&head[62][62],"%d",&j);
      sscanf(&head[62][37],"%f",&x);
      if(j>=8 || x==0.)sscanf(&head[62][20],"%f",&a2); }
    if(head[63][29]!=32){ sscanf(&head[63][62],"%d",&j);
      sscanf(&head[63][37],"%f",&x);
      if(j>=8 || x==0.)sscanf(&head[63][20],"%f",&a3); }
    if(head[64][29]!=32){ sscanf(&head[64][62],"%d",&j);
      sscanf(&head[64][37],"%f",&x);
      if(j>=8 || x==0.)sscanf(&head[64][20],"%f",&a4); }

  strcpy(t,&f1[i+7]); color=t[5];
  for(j=0;j<strlen(t);j++)if(t[j]<48 || t[j]>57)t[j]=32;
  sscanf(t,"%d %d %d",&date,&num,&ccdno);
    fprintf(fp2,"%s%5d%7.3f%6.3f%5d%8.2f%5.2f%6.3f%6.3f%5d%6.3f%6.3f%6.3f%6.3f%4d %s\n",
          &f1[i],usl,c1,r1,u1,sky1,see1,c3,r3,u3,a1,a2,a3,a4,ie,obj);
    goto l10;
l20:
    fclose(fp1); 
  }
  fclose(fp2);
  printf("\n---> calig.dat\n");
}

